@use 'sass:color';
@use "sass:map";

@import 'variables.colors';

// --------
// -- Breakpoints
// --------

/* stylelint-disable unit-allowed-list */
$breakpoints: (
  xs: 540px,
  s: 768px,
  m: 992px,
  l: 1200px,
  xl: 1400px
);
/* stylelint-enable unit-allowed-list */

// --------
// -- Sizing
// --------

$cui-height: (
  xl: 3.5rem,
  l: 3rem,
  m: 2.5rem,
  s: 2rem,
  xs: 1.5rem
);

$cui-border-radius: (
  l: var(--cui-border-radius-l, .5rem),
  m: var(--cui-border-radius-m, .25rem),
  s: var(--cui-border-radius-s, .125rem)
);

// --------
// -- Color Palettes
// --------

$cui-primary: (
  bg: var(--cui-primary-bg, $cui-b400),
  bg-hover: var(--cui-primary-bg-hover, $cui-b300),
  bg-active: var(--cui-primary-bg-active, $cui-b500),
  fill: var(--cui-primary-fill, $cui-n0),
  fill-hover: var(--cui-primary-fill-hover, $cui-n0),
  fill-active: var(--cui-primary-fill-active, $cui-n0),
  text: var(--cui-primary-text, $cui-b400),
  text-hover: var(--cui-primary-text-hover, $cui-b400),
  text-active: var(--cui-primary-text-active, $cui-b400),
  input-border: var(--cui-primary-input-border, $cui-n75),
  input-border-hover: var(--cui-primary-input-border-hover, $cui-n100),
  input-background: var(--cui-primary-input-background, $cui-n0),
  input-background-hover: var(--cui-primary-input-background-hover, $cui-n0),
);

$cui-secondary: (
  bg: var(--cui-secondary-bg, $cui-n35),
  bg-hover: var(--cui-secondary-bg-hover, $cui-n50),
  bg-active: var(--cui-secondary-bg-active, $cui-n75),
  fill: var(--cui-secondary-fill, $cui-n400),
  fill-hover: var(--cui-secondary-fill-hover, $cui-n400),
  fill-active: var(--cui-secondary-fill-active, $cui-n400),
  text: var(--cui-secondary-text, $cui-n200),
  text-hover: var(--cui-secondary-text-hover, $cui-n200),
  text-active: var(--cui-secondary-text-active, $cui-n200),
  input-border: var(--cui-secondary-input-border, transparent),
  input-border-hover: var(--cui-secondary-input-border-hover, transparent),
  input-background: var(--cui-secondary-input-background, $cui-n35),
  input-background-hover: var(--cui-secondary-input-background-hover, $cui-n50),
);

$cui-ghost: (
  bg: var(--cui-ghost-bg, transparent),
  bg-hover: var(--cui-ghost-bg-hover, $cui-n35),
  bg-active: var(--cui-ghost-bg-active, $cui-n50),
  fill: var(--cui-ghost-fill, $cui-n200),
  fill-hover: var(--cui-ghost-fill-hover, $cui-n400),
  fill-active: var(--cui-ghost-fill-active, $cui-n400),
  text: var(--cui-ghost-text, $cui-n200),
  text-hover: var(--cui-ghost-text-hover, $cui-n200),
  text-active: var(--cui-ghost-text-active, $cui-n200),
  input-border: var(--cui-ghost-input-border, transparent),
  input-border-hover: var(--cui-ghost-input-border-hover, transparent),
  input-background: var(--cui-ghost-input-background, transparent),
  input-background-hover: var(--cui-ghost-input-background-hover, transparent)
);

$cui-note: (
  bg: var(--cui-note-bg, $cui-p400),
  bg-hover: var(--cui-note-bg-hover, $cui-p300),
  bg-active: var(--cui-note-bg-active, $cui-p500),
  fill: var(--cui-note-fill, $cui-n0),
  fill-hover: var(--cui-note-fill-hover, $cui-n0),
  fill-active: var(--cui-note-fill-active, $cui-n0),
  text: var(--cui-note-text, $cui-p400),
  text-hover: var(--cui-note-text-hover, $cui-p400),
  text-active: var(--cui-note-text-active, $cui-p400)
);

$cui-info: (
  bg: var(--cui-info-bg, $cui-b300),
  bg-hover: var(--cui-info-bg-hover, $cui-b200),
  bg-active: var(--cui-info-bg-active, $cui-b400),
  fill: var(--cui-info-fill, $cui-n0),
  fill-hover: var(--cui-info-fill-hover, $cui-n0),
  fill-active: var(--cui-info-fill-active, $cui-n0),
  text: var(--cui-info-text, $cui-b300),
  text-hover: var(--cui-info-text-hover, $cui-b300),
  text-active: var(--cui-info-text-active, $cui-b300)
);

$cui-success: (
  bg: var(--cui-success-bg, $cui-g400),
  bg-hover: var(--cui-success-bg-hover, $cui-g300),
  bg-active: var(--cui-success-bg-active, $cui-g500),
  fill: var(--cui-success-fill, $cui-n0),
  fill-hover: var(--cui-success-fill-hover, $cui-n0),
  fill-active: var(--cui-success-fill-active, $cui-n0),
  text: var(--cui-success-text, $cui-g400),
  text-hover: var(--cui-success-text-hover, $cui-g400),
  text-active: var(--cui-success-text-active, $cui-g400)
);

$cui-warning: (
  bg: var(--cui-warning-bg, $cui-o400),
  bg-hover: var(--cui-warning-bg-hover, $cui-o300),
  bg-active: var(--cui-warning-bg-active, $cui-o500),
  fill: var(--cui-warning-fill, $cui-n0),
  fill-hover: var(--cui-warning-fill-hover, $cui-n0),
  fill-active: var(--cui-warning-fill-active, $cui-n0),
  text: var(--cui-warning-text, $cui-o400),
  text-hover: var(--cui-warning-text-hover, $cui-o400),
  text-active: var(--cui-warning-text-active, $cui-o400)
);

$cui-error: (
  bg: var(--cui-error-bg, $cui-r400),
  bg-hover: var(--cui-error-bg-hover, $cui-r300),
  bg-active: var(--cui-error-bg-active, $cui-r500),
  fill: var(--cui-error-fill, $cui-n0),
  fill-hover: var(--cui-error-fill-hover, $cui-n0),
  fill-active: var(--cui-error-fill-active, $cui-n0),
  text: var(--cui-error-text, $cui-r400),
  text-hover: var(--cui-error-text-hover, $cui-r400),
  text-active: var(--cui-error-text-active, $cui-r400)
);

$cui-custom: (
  bg: var(--cui-custom-bg),
  bg-hover: var(--cui-custom-bg-hover),
  bg-active: var(--cui-custom-bg-active),
  fill: var(--cui-custom-fill),
  fill-hover: var(--cui-custom-fill-hover),
  fill-active: var(--cui-custom-fill-active),
  text: var(--cui-custom-text),
  text-hover: var(--cui-custom-text-hover),
  text-active: var(--cui-custom-text-active)
);

$cui-palettes: (
  primary: $cui-primary,
  secondary: $cui-secondary,
  ghost: $cui-ghost,
  note: $cui-note,
  info: $cui-info,
  success: $cui-success,
  warning: $cui-warning,
  error: $cui-error,
  custom: $cui-custom
);

// --------
// -- Typography
// --------

$cui-font: "Source Sans Pro";
$cui-font-fallback: system-ui, -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, "Noto Sans", "Liberation Sans", sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji";
$cui-font-code: "Source Code Pro";
$cui-font-code-fallback: SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace;

$cui-font-weight-h: 600;
$cui-font-size-h: (
  1: 1.75rem,
  2: 1.5rem,
  3: 1.25rem,
  4: 1.125rem,
  5: .9375rem,
  6: .875rem
);
$cui-line-height-h: (
  1: 2rem,
  2: 1.75rem,
  3: 1.5rem,
  4: 1.5rem,
  5: 1.25rem,
  6: 1rem
);

$cui-font-weight: 400;
$cui-font-size: (
  xl: 1.25rem,
  l: 1.125rem,
  m: .9375rem,
  s: .875rem,
  xs: .75rem
);
$cui-line-height: (
  xl: 1.5rem,
  l: 1.5rem,
  m: 1.25rem,
  s: 1rem,
  xs: 1rem
);

$cui-h-margin-bottom: .5rem;
$cui-p-margin-bottom: 1rem;
$cui-font-size-small: .875em;

$cui-text-color: initial;
$cui-code-color: $cui-n400;
$cui-code-block-color: $cui-n400;
$cui-code-block-background-color: map.get($cui-secondary, bg);
$cui-link-color: map.get($cui-primary, text);
$cui-link-color-hover: map.get($cui-primary, text-hover);
$cui-link-color-active: map.get($cui-primary, text-active);
$cui-mark-color: $cui-o100;
$cui-quote-color: inherit;
$cui-quote-source-color: map.get($cui-secondary, text);
$cui-font-weight-strong: 600;

$cui-table-striped-background-color: $cui-n25;
$cui-table-hover-background-color: $cui-n35;
$cui-table-collapsable-background-color: $cui-n25;
$cui-table-selected-background-color: $cui-n35;

// --------
// -- Elevations
// --------

/* stylelint-disable unit-allowed-list */
$cui-elevation: (
  1: (0 1px 4px 0 rgba(16, 29, 48, 0.20)),
  2: (0 2px 4px -1px rgba(16, 29, 48, 0.20),
      0 4px 5px 0 rgba(16, 29, 48, 0.26),
      0 1px 10px -1px rgba(16, 29, 48, 0.12)),
  3: (0 2px 4px -1px rgba(16, 29, 48, 0.20),
      0 9px 16px -3px rgba(16, 29, 48, 0.14),
      0 10px 20px -8px rgba(16, 29, 48, 0.12)),
  4: (0 2px 4px -1px rgba(16, 29, 48, 0.05),
      0 9px 16px -3px rgba(16, 29, 48, 0.14),
      0 32px 20px -20px rgba(16, 29, 48, 0.20))
);

$cui-elevation-transition: box-shadow 0.3s cubic-bezier(.25, .8, .25, 1);
$cui-elevation-floating-header: inset 0 5px 5px -1px rgba(16, 29, 48, 0.12);
$cui-elevation-floating-footer: inset 0 -5px 5px -1px rgba(16, 29, 48, 0.12);
/* stylelint-enable unit-allowed-list */

// --------
// -- Components
// --------

$cui-hover-transition: .15s linear;

// -- TODO: organize

// form elements

$cui-form-field-margin-bottom: 1rem;
$cui-input-padding-h: .75rem;
$cui-form-label-color: $cui-n200;
$cui-form-label-color-focus: $cui-n600;
$cui-form-prefix-margin-h: .25rem;
$cui-form-prefix-color: var(--cui-input-prefix-color, $cui-n200);
$cui-form-hint-color: $cui-n200;
$cui-form-error-color: $cui-r400;
$cui-disabled-opacity: .65;

// focus

$cui-focus-color: var(--cui-focus-color, $cui-b200);
$cui-focus-transition: .15s linear;

// colors

$cui-default-icon-color: $cui-n200;
$cui-default-border-color: $cui-n50;

$cui-input-bg-color: var(--cui-input-bg-color, $cui-n0);
$cui-input-border-color: var(--cui-input-border-color, $cui-n75);
$cui-input-border-color-hover: var(--cui-input-border-color-hover, $cui-n100);
$cui-input-border-color-error: $cui-r300;
$cui-input-placeholder-color: var(--cui-input-placeholder-color, $cui-n200);


// --- skeletons

$cui-skeleton-bg-color: $cui-n35;

// --- cards

$cui-card-padding-outer: 1.5rem;
$cui-card-padding-inner: 1rem;
$cui-card-stacked-padding-outer: 1rem;
$cui-card-stacked-padding-inner: 1rem;
$cui-card-bg-color: $cui-n0;
$cui-card-padding: (
  l: 1.5rem,
  m: 1rem,
  s: 0.5rem
);

// --- tabs

$cui-tab-label-height: 3rem;
// stylelint-disable-next-line unit-allowed-list
$cui-tab-label-bar-height: 2px;

// --- dialogs

$cui-dialog-bg-color: var(--cui-dialog-bg-color, $cui-n0);
/* stylelint-disable unit-allowed-list */
$cui-dialog-width-lg: var(--cui-dialog-width-lg, 960px);
$cui-dialog-width-md: var(--cui-dialog-width-md, 640px);
$cui-dialog-width-sm: var(--cui-dialog-width-sm, 400px);
/* stylelint-enable unit-allowed-list */

// --- tooltips

$cui-tooltip-bg-color: color.adjust($cui-n600, $alpha: -0.15);
$cui-tooltip-text-color: $cui-n0;
$cui-tooltip-border-radius: map.get($cui-border-radius, m);
$cui-tooltip-padding: .25rem .5rem;

// --- toasts

$cui-toast-bg-color: $cui-n0;
$cui-toast-text-color: $cui-n600;
$cui-toast-icon-color: $cui-n200;
$cui-toast-width: 20rem;
$cui-toast-padding: 1rem;
$cui-toast-border-radius: map.get($cui-border-radius, l);

// --- badges

$cui-badge-border-radius: map.get($cui-border-radius, m);

// --- alert

$cui-alert-background-base: $cui-n0;
$cui-alert-background-opacity: 0.1;
$cui-alert-border-radius: map.get($cui-border-radius, l);
$cui-alert-padding: (
  l: 1.5rem,
  m: 1rem,
  s: 0.5rem
);

// --- select

$cui-select-value-bg-color: $cui-n35;
$cui-select-value-bg-color-hover: $cui-n50;

// --- popover

$cui-popover-shadow: map.get($cui-elevation, 1);
$cui-popover-bg-color: $cui-n0;
$cui-popover-border-radius: map.get($cui-border-radius, m);
$cui-popover-min-width: null;
$cui-popover-max-width: 40rem;

// --- menus

$cui-menu-border-radius: map.get($cui-border-radius, m);
$cui-menu-bg-color: $cui-n0;
$cui-menu-min-width: 10rem;
$cui-menu-max-width: 20rem;
$cui-menu-shadow: map.get($cui-elevation, 1);
$cui-menu-padding-v: .5rem;
$cui-menu-title-padding: .5rem 1rem;
$cui-menu-title-font-size: map.get($cui-font-size, s);
$cui-menu-title-line-height: map.get($cui-line-height, s);
$cui-menu-title-text-color: $cui-n200;
$cui-menu-item-padding: .625rem 1rem;
$cui-menu-item-font-size: map.get($cui-font-size, m);
$cui-menu-item-line-height: map.get($cui-line-height, m);
$cui-menu-item-text-color: $cui-n600;
$cui-menu-item-hover-color: $cui-n35;

// --- sidebar

$cui-sidebar-z-index: 1001;
$cui-sidebar-overlay-background-color: rgba(0,0,0,0.5);
$cui-sidebar-menu-background: $cui-n0;
$cui-sidebar-animation-speed: .3s;

// --- scrollable

// stylelint-disable unit-allowed-list
$cui-scrollable-shadow: 0 0 4px 1px rgba(16, 29, 48, 0.20);
$cui-scrollable-table-shadow-top: 0 1px 4px 0 rgba(16, 29, 48, 0.20);
$cui-scrollable-table-shadow-bottom: 0 -1px 4px 0 rgba(16, 29, 48, 0.20);
// stylelint-enable unit-allowed-list
